/*********************************************
*  $B1U>=I=<(4o@)8f%i%$%V%i%j(B
*  $BFbB"4X?t$O0J2<(B
*    lcd_init()    ----- $B=i4|2=(B
*    lcd_cmd(cmd)  ----- $B%3%^%s%I=PNO(B
*    lcd_data(chr) ----- $B#1J8;zI=<(=PNO(B
*    lcd_str(ptr)  ----- $BJ8;zNsI=<(=PNO(B
*    lcd_clear()   ----- $BA4>C5n(B
*********************************************/
#include <htc.h>
#include "lcd_lib.h"


/****** $B%G!<%?=PNO%5%V4X?t(B ******/
void lcd_out(unsigned char code, int flag)
{
	if((code & 0x80) != 0)
            DB7 = 1;			//DB7 pin
	else
            DB7 = 0;
	if((code & 0x40) != 0)
            DB6 = 1;			//DB6 pin
	else
            DB6 = 0;
	if((code & 0x20) != 0)
            DB5 = 1;			//DB5 pin
	else
            DB5 = 0;
	if((code & 0x10) != 0)
            DB4 = 1;			//DB4 pin
	else
            DB4 = 0;
	if (flag == 0)
            RS = 1;			//RS pin $BI=<(%G!<%?$N>l9g(B
	else
            RS = 0;			//$B%3%^%s%I%G!<%?$N>l9g(B
	_delay(1);			//NOP
	STB = 1;				//E pin STB out
	_delay(2);			//NOP
	STB = 0;				//E pin STB reset
}
/******* $B#1J8;zI=<(4X?t(B ******/
void lcd_data(unsigned char asci)
{
	lcd_out(asci, 0);		//$B>e0L#4%S%C%H=PNO(B
	lcd_out(asci<<4, 0);            //$B2<0L#4%S%C%H=PNO(B
	__delay_us(50);                 //50$B&L(Bsec$BBT$A(B
}
/****** $BJ8;zNsI=<(4X?t(B ******/
void lcd_str(unsigned char* ptr)
{
	while(*ptr != 0)		//$BJ8;z<h$j=P$7(B
            lcd_data(*ptr++);	//$BJ8;zI=<((B
}
/****** $B%3%^%s%I=PNO4X?t(B ****/
void lcd_cmd(unsigned char cmd)
{
	lcd_out(cmd, 1);		//$B>e0L#4%S%C%H=PNO(B
	lcd_out(cmd<<4, 1);             //$B2<0L#4%S%C%H=PNO(B
	/* Clear$B$+(BHome$B$+(B */
	if((cmd == 0x01)||(cmd == 0x02))
            __delay_ms(2);          // 2msec$BBT$A(B
	else
            __delay_us(50);         // 50$B&L(Bsec$BBT$A(B
}
/****** $BA4>C5n4X?t(B *****/
void lcd_clear(void)
{
	lcd_cmd(0x01);			//$B=i4|2=%3%^%s%I=PNO(B
}
/***** CGRAM$B@_Dj(B  *****/
void lcd_cgram(int code, unsigned char* ptr)
{
	int i;

	for(i=0; i<8; i++){		// 8$B%P%$%H7+$jJV$7(B
		lcd_cmd(0x40+code*8+i); // CGRAM$B%"%I%l%9%;%C%H(B
		lcd_data(*ptr++);	// 8$B%S%C%H%G!<%?=q$-9~$_(B
	}
}
/****** $B=i4|2=4X?t(B ******/
void lcd_init(void)
{
	__delay_ms(50);
	lcd_out(0x30, 1);			//8bit mode set
	__delay_ms(5);
	lcd_out(0x30, 1);			//8bit mode set
	__delay_ms(1);
	lcd_out(0x30, 1);			//8bit mode set
	__delay_ms(1);
	lcd_out(0x20, 1);			//4bit mode set
	__delay_ms(1);
	lcd_cmd(0x28);			//DL=0 4bit mode
	lcd_cmd(0x08);			//display off C=D=B=0
	lcd_cmd(0x0D);			//display on C=D=1 B=0
	lcd_cmd(0x06);			//entry I/D=1 S=0
	lcd_cmd(0x02);			//cursor home
}

